diff --git a/arch/aarch64/mcount-support.c b/arch/aarch64/mcount-support.c
index a2a80368..6bff5e0e 100644
--- a/arch/aarch64/mcount-support.c
+++ b/arch/aarch64/mcount-support.c
@@ -114,6 +114,7 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 			  struct uftrace_arg_spec *spec)
 {
 	int offset = 1;
+	unsigned long *addr = ctx->stack_base;
 
 	switch (spec->type) {
 	case ARG_TYPE_STACK:
@@ -135,7 +136,12 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 	if (offset < 1 || offset > 100)
 		pr_dbg("invalid stack offset: %d\n", offset);
 
-	memcpy(ctx->val.v, ctx->stack_base + offset, spec->size);
+	addr += offset;
+
+	if (check_mem_region(ctx, (unsigned long)addr))
+		memcpy(ctx->val.v, addr, spec->size);
+	else
+		pr_dbg("stack address is not allowed: %p\n", addr);
 }
 
 void mcount_arch_get_arg(struct mcount_arg_context *ctx,
diff --git a/arch/arm/mcount-support.c b/arch/arm/mcount-support.c
index 17449d23..0dd96e4b 100644
--- a/arch/arm/mcount-support.c
+++ b/arch/arm/mcount-support.c
@@ -412,6 +412,7 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 			  struct uftrace_arg_spec *spec)
 {
 	int offset = 1;
+	unsigned long *addr = ctx->stack_base;
 
 	switch (spec->type) {
 	case ARG_TYPE_STACK:
@@ -441,7 +442,12 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 	if (offset < 1 || offset > 100)
 		pr_dbg("invalid stack offset: %d\n", offset);
 
-	memcpy(ctx->val.v, ctx->stack_base + offset, spec->size);
+	addr += offset;
+
+	if (check_mem_region(ctx, (unsigned long)addr))
+		memcpy(ctx->val.v, addr, spec->size);
+	else
+		pr_dbg("stack address is not allowed: %p\n", addr);
 }
 
 void mcount_arch_get_arg(struct mcount_arg_context *ctx,
diff --git a/arch/i386/mcount-support.c b/arch/i386/mcount-support.c
index eafed101..65b034af 100644
--- a/arch/i386/mcount-support.c
+++ b/arch/i386/mcount-support.c
@@ -81,6 +81,7 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
                         struct uftrace_arg_spec *spec)
 {
 	int offset;
+	unsigned long *addr = ctx->stack_base;
 
 	switch (spec->type) {
 	case ARG_TYPE_STACK:
@@ -101,7 +102,12 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 	if (offset < 1 || offset > 100)
 		pr_dbg("invalid stack offset: %d\n", offset);
 
-	memcpy(ctx->val.v, ctx->stack_base + offset, spec->size);
+	addr += offset;
+
+	if (check_mem_region(ctx, (unsigned long)addr))
+		memcpy(ctx->val.v, addr, spec->size);
+	else
+		pr_dbg("stack address is not allowed: %p\n", addr);
 }
 
 void mcount_arch_get_arg(struct mcount_arg_context *ctx,
diff --git a/arch/x86_64/mcount-support.c b/arch/x86_64/mcount-support.c
index 82f998bc..1621d8a9 100644
--- a/arch/x86_64/mcount-support.c
+++ b/arch/x86_64/mcount-support.c
@@ -85,6 +85,7 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 			  struct uftrace_arg_spec *spec)
 {
 	int offset;
+	unsigned long *addr = ctx->stack_base;
 
 	switch (spec->type) {
 	case ARG_TYPE_STACK:
@@ -106,7 +107,12 @@ void mcount_get_stack_arg(struct mcount_arg_context *ctx,
 	if (offset < 1 || offset > 100)
 		pr_dbg("invalid stack offset: %d\n", offset);
 
-	memcpy(ctx->val.v, ctx->stack_base + offset, spec->size);
+	addr += offset;
+
+	if (check_mem_region(ctx, (unsigned long)addr))
+		memcpy(ctx->val.v, addr, spec->size);
+	else
+		pr_dbg("stack address is not allowed: %p\n", addr);
 }
 
 void mcount_arch_get_arg(struct mcount_arg_context *ctx,
diff --git a/libmcount/internal.h b/libmcount/internal.h
index 712828a8..de037918 100644
--- a/libmcount/internal.h
+++ b/libmcount/internal.h
@@ -387,6 +387,9 @@ void save_trigger_read(struct mcount_thread_data *mtdp,
 		       enum trigger_read_type type, bool diff);
 #endif  /* DISABLE_MCOUNT_FILTER */
 
+bool check_mem_region(struct mcount_arg_context *ctx,
+		      unsigned long addr);
+
 void save_watchpoint(struct mcount_thread_data *mtdp,
 		     struct mcount_ret_stack *rstack,
 		     unsigned long watchpoints);
diff --git a/libmcount/record.c b/libmcount/record.c
index 9cb8f1ad..7ca5f3f2 100644
--- a/libmcount/record.c
+++ b/libmcount/record.c
@@ -363,8 +363,8 @@ static bool find_mem_region(struct rb_root *root, unsigned long addr)
 	return false;
 }
 
-static bool check_mem_region(struct mcount_arg_context *ctx,
-			     unsigned long addr)
+bool check_mem_region(struct mcount_arg_context *ctx,
+		      unsigned long addr)
 {
 	bool update = true;
 	struct mcount_mem_regions *regions = ctx->regions;
@@ -797,6 +797,12 @@ void save_watchpoint(struct mcount_thread_data *mtdp,
 		     unsigned long watchpoints)
 {
 }
+
+bool check_mem_region(struct mcount_arg_context *ctx,
+		      unsigned long addr)
+{
+	return true;
+}
 #endif
 
 static struct mcount_shmem_buffer * get_shmem_buffer(struct mcount_thread_data *mtdp,
